/*
 Port&Copyright:      Christian Kranz, mail to cnkz at yahoo.com
 Original Copyright:  Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:              Hagen Reddmann
 Remarks:             this Copyright must be included
 known Problems:      none
 Version:             0.1. 2005
 Description:         Graphic Library for Siemens S65, M65, CX65 and RX65 Display
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

// routine
//   void glcdFrame(glcdCoord_t x1, glcdCoord_t y1, glcdCoord_t x2, glcdCoord_t y2);

        .text
        .global glcdFrame               // used T0,T1,D0,D1,__temp_reg__,__zero_reg__  stack 3
glcdFrame:
        fcall   glcdDoCheckCoord
glcdDoFrame:
        ldi     D0, COLOR_INDEX_SH
        fcall   glcdDoGetColor
        breq    glcdDoFrame1
        fcall   glcdDoSaveCoords
        subi    X1L, lo8(-4)
        subi    X2L, lo8( 2)
        mov     Y1L, Y2L
        fcall   glcdDoFillRect          // glcdDoFillRect(x1 + 4, y2, x2 - 2, y2, glcdShColor)
        fcall   glcdDoRestoreCoords
        mov     X1L, X2L
        subi    Y1L, lo8(-4)
        subi    Y2L, lo8( 2)
        fcall   glcdDoFillRect          // glcdDoFillRect(x2, y1 +4, x2, y2 -2, glcdShColor)
        fcall   glcdDoRestoreCoords
        dec     X2L
        mov     X1L, X2L
        dec     X1L
        dec     Y2L
        mov     Y1L, Y2L
        dec     Y1L
        fcall   glcdDoFillRect          // glcdDoFillRect(x2 -2, y2 -2, x2 -1, y2 -1, glcdShColor)
        fcall   glcdDoRestoreCoords
        dec     X2L
        dec     Y2L
glcdDoFrame1:
        ldi     D0, COLOR_INDEX_FR
        fcall   glcdDoGetColor
        breq    glcdDoFrame2
        fcall   glcdDoSaveCoords
        subi    X1L, lo8(-2)
        subi    X2L, lo8( 2)
        mov     Y2L, Y1L
        fcall   glcdDoFillRect          // glcdDoFillRect(x1 +2, y1, x2 -2, y1, glcdFrColor)
        fcall   glcdDoRestoreCoords
        subi    X1L, lo8(-2)
        mov     Y1L, Y2L
        subi    X2L, lo8( 2)
        fcall   glcdDoFillRect          // glcdDoFillRect(x1 +2, y2, x2 -2, y2, glcdFrColor)
        fcall   glcdDoRestoreCoords
        subi    Y1L, lo8(-2)
        mov     X1L, X2L
        subi    Y2L, lo8( 2)
        fcall   glcdDoFillRect          // glcdDoFillRect(x2, y1 +2, x2, y2 -2, glcdFrColor)
        fcall   glcdDoRestoreCoords
        subi    Y1L, lo8(-2)
        mov     X2L, X1L
        subi    Y2L, lo8( 2)
        fcall   glcdDoFillRect          // glcdDoFillRect(x1, y1 +2, x1, y2 -2, glcdFrColor)
        fcall   glcdDoRestoreCoords
        inc     X1L
        inc     Y1L
        dec     X2L
        dec     Y2L
        fcall   glcdDoSaveCoords
        fcall   glcdDoSetPixel          // glcdDoSetPixel(x1, y1, glcdFrColor)
        mov     X1L, X1H
        mov     Y1L, Y2H
        fcall   glcdDoSetPixel          // glcdSetPixel(x1, y2, glcdFrColor)
        mov     X1L, X2H
        mov     Y1L, Y1H
        fcall   glcdDoSetPixel          // glcdSetPixel(x2, y1, glcdFrColor)
        mov     X1L, X2H
        mov     Y1L, Y2H
        fcall   glcdDoSetPixel          // glcdSetPixel(x2, y2, glcdFrColor);
        fcall   glcdDoRestoreCoords
glcdDoFrame2:
        ldi     D0, COLOR_INDEX_BK      // fill interior with background color
        fcall   glcdDoGetColor
        breq    glcdDoFrame3
        fcall   glcdDoSaveCoords
        inc     Y1L
        dec     Y2L
        mov     X2L, X1L
        fcall   glcdDoFillRect          // glcdDoFillRect(x1, y1 +1, x1, y2 -1, glcdBkColor);
        fcall   glcdDoRestoreCoords
        inc     Y1L
        dec     Y2L
        mov     X1L, X2L
        fcall   glcdDoFillRect          // glcdDoFillRect(x2, y1 +1, x2, y2 -1, glcdBkColor);
        fcall   glcdDoRestoreCoords
        inc     X1L
        dec     X2L
        fjmp    glcdDoFillRect          // glcdDoFillRect(x1 +1, y1, x2 -1, y2, glcdBkColor);
glcdDoFrame3:
        ret

.end

