/*
 Port&Copyright:      Christian Kranz, mail to cnkz at yahoo.com
 Original Copyright:  Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:              Hagen Reddmann
 Remarks:             this Copyright must be included
 known Problems:      none
 Version:             0.1. 2005
 Description:         Graphic Library for Siemens S65, M65, CX65 and RX65 Display
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .text
        
// void glcdSetAddr(glcdCoord_t x1, glcdCoord_t y1, glcdCoord_t x2, glcdCoord_t y2);   
// set RAM access pointer of display
// from regs.inc
//#define     X1              P0
//#define     Y1              P1
//#define     X2              P2
//#define     Y2              P3
        .global glcdSetAddr             // used T0,T1 stack 1
glcdSetAddr:
// memory definition command

    ldi     T1,0xEF
    fcall   glcdDispCommand
    ldi     T1,0x90
    fcall   glcdDispCommand

    lds     T0, glcd_MemCtrl        // don't touch D0,D1,__tmp_reg__,__zero_reg__
    sbrc    T0, MEM_90              // if MEM_90 bit in T0 is clear, do not swap X and Y
    fjmp    glcdSetAddr_rotate
        // berspringe nchsten Befehl, wenn bit MEM_90 in T0 clear ist... MEM_90 ist 0

// (X=0,Y=0) point is upper left corner
// write from Y1 to Y2 in positive Y-direction
// write from X1 to X2 column by column
    ldi     T1,0x05
    fcall   glcdDispCommand
    ldi     T1,0x04
    fcall   glcdDispCommand
// X-direction end point
    ldi     T1,0x09
    fcall   glcdDispCommand
    mov     T1,X2
    fcall   glcdDispCommand
// x-direction start point
    ldi     T1,0x08
    fcall   glcdDispCommand
    mov     T1,X1
    fcall   glcdDispCommand
// y-direction end point
    ldi     T1,0x0B
    fcall   glcdDispCommand
    mov     T1,Y2
    fcall   glcdDispCommand
// y-direction start point
    ldi     T1,0x0A
    fcall   glcdDispCommand
    mov     T1,Y1
    fjmp    glcdDispCommand  // and ret


glcdSetAddr_rotate:
// (X=0,Y=0) point is upper left corner
// write from X1 to X2 in positive X-direction
// write from Y1 to Y2 row by row

    ldi     T1,0x05
    fcall   glcdDispCommand
    ldi     T1,0x00
    fcall   glcdDispCommand
// X-direction end point
    ldi     T1,0x09
    fcall   glcdDispCommand
    mov     T1,Y2
    fcall   glcdDispCommand
// x-direction start point
    ldi     T1,0x08
    fcall   glcdDispCommand
    mov     T1,Y1
    fcall   glcdDispCommand
// y-direction end point
    ldi     T1,0x0B
    fcall   glcdDispCommand
    mov     T1,X2
    fcall   glcdDispCommand
// y-direction start point
    ldi     T1,0x0A
    fcall   glcdDispCommand
    mov     T1,X1
    fjmp    glcdDispCommand  // and ret

.end
